                                                                                                                                                      
 MODULE mod_chem_spack_jacdchemdc                                                                                                                     
                                                                                                                                                      
   USE mod_chem_spack_dratedc, ONLY: dratedc  ! subroutine                                                                                            
   IMPLICIT NONE                                                                                                                                      
   PRIVATE                                                                                                                                            
   PUBLIC :: jacdchemdc ! subroutine                                                                                                                  
 CONTAINS                                                                                                                                             
                                                                                                                                                      
   SUBROUTINE jacdchemdc(y,rk,JacC,ngas,ijkbeg,ijkend,maxblock_size,nr)                                                                               
                                                                                                                                                      
!------------------------------------------------------------------------                                                                             
!                                                                                                                                                     
!     -- DESCRIPTION                                                                                                                                  
!                                                                                                                                                     
!     This routine computes the Jacobian matrix for the gas-phase.                                                                                    
!     This routine is automatically generated by SPACK.                                                                                               
!     Mechanism: ../Mechanism/CB07                                                                                                                    
!     Species: ../Mechanism/ciCB07                                                                                                                    
!                                                                                                                                                     
!------------------------------------------------------------------------                                                                             
!                                                                                                                                                     
!     -- INPUT VARIABLES                                                                                                                              
!                                                                                                                                                     
!     Y: chemical concentrations.                                                                                                                     
!     RK: kinetic rates.                                                                                                                              
!                                                                                                                                                     
!     -- INPUT/OUTPUT VARIABLES                                                                                                                       
!                                                                                                                                                     
!     -- OUTPUT VARIABLES                                                                                                                             
!                                                                                                                                                     
!     JACC: Jacobian matrix.                                                                                                                          
!                                                                                                                                                     
!------------------------------------------------------------------------                                                                             
!                                                                                                                                                     
!     -- REMARKS                                                                                                                                      
!                                                                                                                                                     
!     The matrix JACC could be stored in a low-dimensional vector.                                                                                    
!                                                                                                                                                     
!------------------------------------------------------------------------                                                                             
!                                                                                                                                                     
!     -- MODIFICATIONS                                                                                                                                
!                                                                                                                                                     
!------------------------------------------------------------------------                                                                             
!                                                                                                                                                     
!     -- AUTHOR(S)                                                                                                                                    
!                                                                                                                                                     
!     SPACK.                                                                                                                                          
!                                                                                                                                                     
!------------------------------------------------------------------------                                                                             
                                                                                                                                                      
      IMPLICIT NONE                                                                                                                                   
                                                                                                                                                      
                                                                                                                                                      
       INTEGER 	 , INTENT(IN)  :: ngas                                                                                                                
       INTEGER 	 , INTENT(IN)  :: ijkbeg			                                                                                                           
       INTEGER 	 , INTENT(IN)  :: ijkend			                                                                                                           
       INTEGER 	 , INTENT(IN)  :: maxblock_size 		                                                                                                    
       INTEGER 	 , INTENT(IN)  :: nr 				                                                                                                             
       DOUBLE PRECISION , INTENT(IN)  :: rk(maxblock_size,nr)		                                                                                       
       DOUBLE PRECISION , INTENT(IN)  :: y(maxblock_size,NGAS) 	                                                                                      
       DOUBLE PRECISION , INTENT(OUT) :: JacC(maxblock_size,NGAS,NGAS)                                                                                
       								                                                                                                                                       
       DOUBLE PRECISION :: dw(maxblock_size,nr,NGAS)			                                                                                               
       INTEGER :: ijk							                                                                                                                          
                                                                                                                                                      
                                                                                                                                                      
      CALL dratedc(rk,y,dw,ngas,ijkbeg,ijkend,maxblock_size,nr)                                                                                       
                                                                                                                                                      
      DO ijk=ijkbeg,ijkend                                                                                                                            
      JacC(ijk,  1,  1) =  - dw(ijk,  1,  1) &
                           - dw(ijk, 28,  1) &
                           - dw(ijk, 29,  1) &
                           - dw(ijk, 31,  1) &
                           - dw(ijk, 34,  1) &
                           - dw(ijk, 41,  1) &
                           - dw(ijk, 43,  1) &
                           - dw(ijk, 47,  1) &
                           - dw(ijk, 61,  1) &
                           - dw(ijk, 68,  1) &
                           - dw(ijk, 80,  1) &
                           - dw(ijk, 89,  1)
      JacC(ijk,  2,  1) =  + dw(ijk,  1,  1) &
                           + dw(ijk, 28,  1) &
                           - dw(ijk, 43,  1) &
                           + dw(ijk, 46,  1) &
                          + 0.2000000000000000D+00*dw(ijk, 80,  1)
      JacC(ijk,  3,  1) =  + dw(ijk,  1,  1) &
                           - dw(ijk, 28,  1) &
                           - dw(ijk, 29,  1)
      JacC(ijk,  4,  4) =  - dw(ijk,  2,  4) &
                           - dw(ijk,  3,  4) &
                           - dw(ijk, 17,  4) &
                           - dw(ijk, 21,  4) &
                           - dw(ijk, 22,  4) &
                           - dw(ijk, 40,  4) &
                           - dw(ijk, 41,  4) &
                           - dw(ijk, 71,  4) &
                           - dw(ijk, 74,  4) &
                           - dw(ijk, 78,  4) &
                           - dw(ijk, 82,  4) &
                           - dw(ijk, 91,  4)
      JacC(ijk,  6,  4) =  + dw(ijk,  2,  4)
      JacC(ijk,  3,  4) =  + dw(ijk,  3,  4) &
                           - dw(ijk, 17,  4)
      JacC(ijk,  2, 11) =  + dw(ijk,  4, 11) &
                           + dw(ijk, 44, 11) &
                           + dw(ijk, 44, 11)
      JacC(ijk, 11, 11) =  - dw(ijk,  4, 11) &
                           - dw(ijk, 37, 11) &
                          - 0.2000000000000000D+01*dw(ijk, 44, 11) &
                          - 0.2000000000000000D+01*dw(ijk, 44, 11)
      JacC(ijk,  1, 10) =  + dw(ijk,  5, 10)
      JacC(ijk,  7, 10) =  + dw(ijk,  5, 10) &
                           - dw(ijk, 38, 10)
      JacC(ijk, 10, 10) =  - dw(ijk,  5, 10) &
                           - dw(ijk, 38, 10)
      JacC(ijk,  1, 12) = + 0.6500000000000000D+00*dw(ijk,  6, 12) &
                           + dw(ijk, 35, 12) &
                           + dw(ijk, 39, 12)
      JacC(ijk,  5, 12) = + 0.3500000000000000D+00*dw(ijk,  6, 12)
      JacC(ijk,  7, 12) = + 0.3500000000000000D+00*dw(ijk,  6, 12) &
                           - dw(ijk, 39, 12)
      JacC(ijk,  8, 12) = + 0.6500000000000000D+00*dw(ijk,  6, 12) &
                           + dw(ijk, 35, 12)
      JacC(ijk, 12, 12) =  - dw(ijk,  6, 12) &
                           - dw(ijk, 35, 12) &
                           - dw(ijk, 39, 12)
      JacC(ijk,  2,  5) =  + dw(ijk,  7,  5) &
                           - dw(ijk, 45,  5) &
                           + dw(ijk, 46,  5)
      JacC(ijk,  5,  5) =  - dw(ijk,  7,  5) &
                           - dw(ijk,  8,  5) &
                           - dw(ijk, 32,  5) &
                           - dw(ijk, 36,  5) &
                           - dw(ijk, 45,  5) &
                           - dw(ijk, 46,  5) &
                           - dw(ijk, 47,  5) &
                          - 0.2000000000000000D+01*dw(ijk, 51,  5) &
                          - 0.2000000000000000D+01*dw(ijk, 51,  5) &
                           - dw(ijk, 56,  5) &
                           - dw(ijk, 59,  5) &
                           - dw(ijk, 75,  5) &
                           - dw(ijk, 79,  5) &
                           - dw(ijk, 83,  5) &
                           - dw(ijk, 88,  5)
      JacC(ijk,  1,  5) =  + dw(ijk,  8,  5) &
                           + dw(ijk, 32,  5) &
                          + 0.7000000000000000D+00*dw(ijk, 36,  5) &
                          + 0.2000000000000000D+01*dw(ijk, 45,  5) &
                           - dw(ijk, 47,  5) &
                          + 0.2000000000000000D+01*dw(ijk, 51,  5) &
                          + 0.2000000000000000D+01*dw(ijk, 51,  5) &
                           + dw(ijk, 75,  5) &
                          + 0.2000000000000000D+00*dw(ijk, 79,  5)
      JacC(ijk,  3,  5) =  + dw(ijk,  8,  5)
      JacC(ijk, 13, 13) =  - dw(ijk,  9, 13) &
                           - dw(ijk, 24, 13)
      JacC(ijk, 14, 15) =  + dw(ijk, 10, 15) &
                           + dw(ijk, 11, 15) &
                           + dw(ijk, 54, 15) &
                           + dw(ijk, 55, 15) &
                           + dw(ijk, 56, 15)
      JacC(ijk, 15, 15) =  - dw(ijk, 10, 15) &
                           - dw(ijk, 11, 15) &
                           - dw(ijk, 54, 15) &
                           - dw(ijk, 55, 15) &
                           - dw(ijk, 56, 15)
      JacC(ijk,  8, 15) = + 0.2000000000000000D+01*dw(ijk, 11, 15) &
                           + dw(ijk, 54, 15) &
                           + dw(ijk, 55, 15) &
                           + dw(ijk, 56, 15)
      JacC(ijk,  8, 16) = + 0.2000000000000000D+01*dw(ijk, 12, 16)
      JacC(ijk, 14, 16) =  + dw(ijk, 12, 16)
      JacC(ijk, 15, 16) =  + dw(ijk, 12, 16)
      JacC(ijk, 16, 16) =  - dw(ijk, 12, 16) &
                           - dw(ijk, 57, 16) &
                           - dw(ijk, 58, 16) &
                           - dw(ijk, 59, 16)
      JacC(ijk, 18, 16) =  + dw(ijk, 12, 16)
      JacC(ijk,  8, 33) = + 0.1033000000000000D+01*dw(ijk, 13, 33) &
                          + 0.5030000000000000D+00*dw(ijk, 81, 33) &
                          + 0.1540000000000000D+00*dw(ijk, 82, 33) &
                          + 0.9250000000000000D+00*dw(ijk, 83, 33)
      JacC(ijk, 14, 33) = + 0.3330000000000000D+00*dw(ijk, 13, 33) &
                          + 0.3340000000000000D+00*dw(ijk, 81, 33) &
                          + 0.2250000000000000D+00*dw(ijk, 82, 33) &
                          + 0.6430000000000000D+00*dw(ijk, 83, 33)
      JacC(ijk, 15, 33) = + 0.9000000000000000D+00*dw(ijk, 13, 33) &
                          + 0.1670000000000000D+00*dw(ijk, 81, 33) &
                          + 0.1500000000000000D+00*dw(ijk, 82, 33) &
                          + 0.2820000000000000D+00*dw(ijk, 83, 33)
      JacC(ijk, 16, 33) = + 0.6700000000000000D-01*dw(ijk, 13, 33) &
                          + 0.2730000000000000D+00*dw(ijk, 81, 33) &
                          + 0.2000000000000000D-01*dw(ijk, 82, 33) &
                          + 0.3570000000000000D+00*dw(ijk, 83, 33)
      JacC(ijk, 17, 33) = + 0.9670000000000000D+00*dw(ijk, 13, 33) &
                          + 0.4980000000000000D+00*dw(ijk, 81, 33) &
                          + 0.1140000000000000D+00*dw(ijk, 82, 33) &
                          + 0.7500000000000000D-01*dw(ijk, 83, 33)
      JacC(ijk, 18, 33) = + 0.7000000000000000D+00*dw(ijk, 13, 33) &
                          + 0.7130000000000000D+00*dw(ijk, 81, 33) &
                          + 0.6400000000000000D-01*dw(ijk, 82, 33) &
                          + 0.7500000000000000D-01*dw(ijk, 83, 33)
      JacC(ijk, 20, 33) = + 0.8320000000000000D+00*dw(ijk, 13, 33) &
                          + 0.1565000000000000D+01*dw(ijk, 81, 33) &
                          + 0.3600000000000000D+00*dw(ijk, 82, 33) &
                          + 0.1282000000000000D+01*dw(ijk, 83, 33)
      JacC(ijk, 33, 33) =  - dw(ijk, 13, 33) &
                           - dw(ijk, 81, 33) &
                           - dw(ijk, 82, 33) &
                           - dw(ijk, 83, 33)
      JacC(ijk,  8, 28) =  + dw(ijk, 14, 28) &
                          + 0.2000000000000000D+01*dw(ijk, 90, 28) &
                          + 0.7600000000000000D+00*dw(ijk, 91, 28)
      JacC(ijk, 14, 28) =  + dw(ijk, 14, 28) &
                          + 0.2000000000000000D+01*dw(ijk, 90, 28) &
                          + 0.6899999999999999D+00*dw(ijk, 91, 28)
      JacC(ijk, 17, 28) =  + dw(ijk, 14, 28) &
                           + dw(ijk, 90, 28) &
                          + 0.6200000000000000D+00*dw(ijk, 91, 28)
      JacC(ijk, 28, 28) =  - dw(ijk, 14, 28) &
                           - dw(ijk, 90, 28) &
                           - dw(ijk, 91, 28)
      JacC(ijk,  8, 30) =  + dw(ijk, 15, 30)
      JacC(ijk, 14, 30) =  + dw(ijk, 15, 30)
      JacC(ijk, 17, 30) =  + dw(ijk, 15, 30) &
                           + dw(ijk, 93, 30)
      JacC(ijk, 30, 30) =  - dw(ijk, 15, 30) &
                           - dw(ijk, 93, 30)
      JacC(ijk,  3,  3) =  - dw(ijk, 16,  3) &
                           - dw(ijk, 17,  3) &
                           - dw(ijk, 27,  3) &
                           - dw(ijk, 28,  3) &
                           - dw(ijk, 29,  3) &
                           - dw(ijk, 54,  3) &
                           - dw(ijk, 57,  3) &
                           - dw(ijk, 69,  3) &
                           - dw(ijk, 72,  3) &
                           - dw(ijk, 76,  3)
      JacC(ijk,  4,  3) =  + dw(ijk, 16,  3) &
                           - dw(ijk, 17,  3)
      JacC(ijk,  3,  6) =  + dw(ijk, 18,  6) &
                           + dw(ijk, 19,  6)
      JacC(ijk,  6,  6) =  - dw(ijk, 18,  6) &
                           - dw(ijk, 19,  6) &
                           - dw(ijk, 20,  6)
      JacC(ijk,  7,  6) = + 0.2000000000000000D+01*dw(ijk, 20,  6)
      JacC(ijk,  4,  7) =  - dw(ijk, 21,  7)
      JacC(ijk,  7,  4) =  - dw(ijk, 21,  4) &
                           + dw(ijk, 22,  4) &
                          + 0.8000000000000000D-01*dw(ijk, 71,  4) &
                          + 0.8500000000000001D-01*dw(ijk, 74,  4) &
                          + 0.2660000000000000D+00*dw(ijk, 78,  4) &
                          + 0.2680000000000000D+00*dw(ijk, 82,  4) &
                          + 0.8000000000000000D-01*dw(ijk, 91,  4)
      JacC(ijk,  7,  7) =  - dw(ijk, 21,  7) &
                           - dw(ijk, 23,  7) &
                           - dw(ijk, 24,  7) &
                           - dw(ijk, 30,  7) &
                           - dw(ijk, 31,  7) &
                           - dw(ijk, 32,  7) &
                           - dw(ijk, 37,  7) &
                           - dw(ijk, 38,  7) &
                           - dw(ijk, 39,  7) &
                           - dw(ijk, 52,  7) &
                           - dw(ijk, 53,  7) &
                           - dw(ijk, 55,  7) &
                           - dw(ijk, 58,  7) &
                           - dw(ijk, 65,  7) &
                           - dw(ijk, 70,  7) &
                           - dw(ijk, 73,  7) &
                           - dw(ijk, 77,  7) &
                           - dw(ijk, 81,  7) &
                           - dw(ijk, 84,  7) &
                           - dw(ijk, 87,  7) &
                           - dw(ijk, 90,  7) &
                           - dw(ijk, 92,  7) &
                           - dw(ijk, 93,  7) &
                           - dw(ijk,101,  7) &
                           - dw(ijk,102,  7) &
                           - dw(ijk,103,  7)
      JacC(ijk,  8,  4) =  + dw(ijk, 21,  4) &
                           - dw(ijk, 22,  4) &
                          + 0.8000000000000000D-01*dw(ijk, 71,  4) &
                          + 0.1500000000000000D+00*dw(ijk, 74,  4) &
                          + 0.6600000000000000D-01*dw(ijk, 78,  4) &
                          + 0.1540000000000000D+00*dw(ijk, 82,  4) &
                          + 0.7600000000000000D+00*dw(ijk, 91,  4)
      JacC(ijk,  8,  7) =  + dw(ijk, 21,  7) &
                           - dw(ijk, 23,  7) &
                           + dw(ijk, 24,  7) &
                           + dw(ijk, 32,  7) &
                           + dw(ijk, 52,  7) &
                           + dw(ijk, 53,  7) &
                           + dw(ijk, 55,  7) &
                          + 0.1100000000000000D+00*dw(ijk, 65,  7) &
                           + dw(ijk, 70,  7) &
                           + dw(ijk, 73,  7) &
                          + 0.9120000000000000D+00*dw(ijk, 77,  7) &
                          + 0.5030000000000000D+00*dw(ijk, 81,  7) &
                          + 0.4400000000000000D+00*dw(ijk, 84,  7) &
                          + 0.6000000000000000D+00*dw(ijk, 87,  7) &
                          + 0.2000000000000000D+01*dw(ijk, 90,  7) &
                          + 0.7000000000000000D+00*dw(ijk, 92,  7) &
                           + dw(ijk,101,  7) &
                           + dw(ijk,102,  7) &
                           + dw(ijk,103,  7)
      JacC(ijk,  4,  8) =  - dw(ijk, 22,  8) &
                          + 0.2500000000000000D+00*dw(ijk, 63,  8)
      JacC(ijk,  7,  8) =  + dw(ijk, 22,  8) &
                           - dw(ijk, 23,  8) &
                           + dw(ijk, 33,  8) &
                          + 0.7000000000000000D+00*dw(ijk, 36,  8)
      JacC(ijk,  8,  8) =  - dw(ijk, 22,  8) &
                           - dw(ijk, 23,  8) &
                          - 0.2000000000000000D+01*dw(ijk, 25,  8) &
                          - 0.2000000000000000D+01*dw(ijk, 25,  8) &
                          - 0.2000000000000000D+01*dw(ijk, 26,  8) &
                          - 0.2000000000000000D+01*dw(ijk, 26,  8) &
                           - dw(ijk, 33,  8) &
                           - dw(ijk, 34,  8) &
                           - dw(ijk, 36,  8) &
                           - dw(ijk, 63,  8) &
                           - dw(ijk, 97,  8) &
                           - dw(ijk, 98,  8)
      JacC(ijk,  7, 13) =  - dw(ijk, 24, 13)
      JacC(ijk,  8, 13) =  + dw(ijk, 24, 13)
      JacC(ijk, 13,  7) =  - dw(ijk, 24,  7)
      JacC(ijk, 13,  8) =  + dw(ijk, 25,  8) &
                           + dw(ijk, 25,  8) &
                           + dw(ijk, 26,  8) &
                           + dw(ijk, 26,  8)
      JacC(ijk,  1,  3) =  + dw(ijk, 27,  3) &
                           - dw(ijk, 28,  3) &
                           - dw(ijk, 29,  3)
      JacC(ijk,  1,  2) =  + dw(ijk, 27,  2) &
                           + dw(ijk, 33,  2) &
                           + dw(ijk, 40,  2) &
                          + 0.2000000000000000D+01*dw(ijk, 42,  2) &
                          + 0.2000000000000000D+01*dw(ijk, 42,  2) &
                           - dw(ijk, 43,  2) &
                          + 0.2000000000000000D+01*dw(ijk, 45,  2) &
                           + dw(ijk, 60,  2) &
                          + 0.9000000000000000D+00*dw(ijk, 85,  2) &
                           + dw(ijk, 94,  2)
      JacC(ijk,  2,  3) =  - dw(ijk, 27,  3) &
                           + dw(ijk, 28,  3)
      JacC(ijk,  2,  2) =  - dw(ijk, 27,  2) &
                           - dw(ijk, 30,  2) &
                           - dw(ijk, 33,  2) &
                           - dw(ijk, 40,  2) &
                          - 0.2000000000000000D+01*dw(ijk, 42,  2) &
                          - 0.2000000000000000D+01*dw(ijk, 42,  2) &
                           - dw(ijk, 43,  2) &
                           - dw(ijk, 45,  2) &
                           - dw(ijk, 60,  2) &
                           - dw(ijk, 85,  2) &
                           - dw(ijk, 94,  2) &
                           - dw(ijk, 95,  2)
      JacC(ijk,  3,  2) =  - dw(ijk, 27,  2)
      JacC(ijk,  5,  3) =  + dw(ijk, 29,  3)
      JacC(ijk,  5,  1) =  + dw(ijk, 29,  1) &
                           + dw(ijk, 41,  1) &
                           - dw(ijk, 46,  1) &
                           - dw(ijk, 47,  1)
      JacC(ijk,  2,  7) =  - dw(ijk, 30,  7)
      JacC(ijk,  7,  2) =  - dw(ijk, 30,  2) &
                           + dw(ijk, 33,  2)
      JacC(ijk, 11,  7) =  + dw(ijk, 30,  7) &
                           - dw(ijk, 37,  7)
      JacC(ijk, 11,  2) =  + dw(ijk, 30,  2) &
                          + 0.2000000000000000D+01*dw(ijk, 43,  2)
      JacC(ijk,  1,  7) =  - dw(ijk, 31,  7) &
                           + dw(ijk, 32,  7) &
                           + dw(ijk, 37,  7) &
                           + dw(ijk, 39,  7)
      JacC(ijk,  7,  1) =  - dw(ijk, 31,  1)
      JacC(ijk, 10,  7) =  + dw(ijk, 31,  7) &
                           - dw(ijk, 38,  7)
      JacC(ijk, 10,  1) =  + dw(ijk, 31,  1)
      JacC(ijk,  5,  7) =  - dw(ijk, 32,  7) &
                           + dw(ijk, 38,  7)
      JacC(ijk,  7,  5) =  - dw(ijk, 32,  5) &
                          + 0.7000000000000000D+00*dw(ijk, 36,  5)
      JacC(ijk,  8,  5) =  + dw(ijk, 32,  5) &
                           - dw(ijk, 36,  5) &
                           + dw(ijk, 56,  5) &
                          + 0.8000000000000000D+00*dw(ijk, 79,  5) &
                          + 0.9250000000000000D+00*dw(ijk, 83,  5)
      JacC(ijk,  1,  8) =  + dw(ijk, 33,  8) &
                           - dw(ijk, 34,  8) &
                          + 0.7000000000000000D+00*dw(ijk, 36,  8)
      JacC(ijk,  2,  8) =  - dw(ijk, 33,  8)
      JacC(ijk,  8,  2) =  - dw(ijk, 33,  2) &
                           + dw(ijk, 60,  2) &
                          + 0.9000000000000000D+00*dw(ijk, 85,  2)
      JacC(ijk,  8,  1) =  - dw(ijk, 34,  1) &
                          + 0.8000000000000000D+00*dw(ijk, 80,  1)
      JacC(ijk, 12,  8) =  + dw(ijk, 34,  8)
      JacC(ijk, 12,  1) =  + dw(ijk, 34,  1)
      JacC(ijk,  5,  8) =  - dw(ijk, 36,  8)
      JacC(ijk, 10,  8) = + 0.3000000000000000D+00*dw(ijk, 36,  8)
      JacC(ijk, 10,  5) = + 0.3000000000000000D+00*dw(ijk, 36,  5) &
                           + dw(ijk, 56,  5) &
                           + dw(ijk, 59,  5) &
                          + 0.7500000000000000D-01*dw(ijk, 83,  5) &
                           + dw(ijk, 88,  5)
      JacC(ijk,  1, 11) =  + dw(ijk, 37, 11) &
                           + dw(ijk, 44, 11) &
                           + dw(ijk, 44, 11)
      JacC(ijk,  7, 11) =  - dw(ijk, 37, 11)
      JacC(ijk,  5, 10) =  + dw(ijk, 38, 10)
      JacC(ijk, 12,  7) =  - dw(ijk, 39,  7)
      JacC(ijk,  1,  4) =  + dw(ijk, 40,  4) &
                           - dw(ijk, 41,  4)
      JacC(ijk,  2,  4) =  - dw(ijk, 40,  4)
      JacC(ijk,  4,  2) =  - dw(ijk, 40,  2)
      JacC(ijk,  4,  1) =  - dw(ijk, 41,  1)
      JacC(ijk,  5,  4) =  + dw(ijk, 41,  4)
      JacC(ijk, 11,  1) = + 0.2000000000000000D+01*dw(ijk, 43,  1)
      JacC(ijk,  5,  2) =  - dw(ijk, 45,  2)
      JacC(ijk,  9,  5) =  + dw(ijk, 47,  5)
      JacC(ijk,  9,  1) =  + dw(ijk, 47,  1)
      JacC(ijk,  1,  9) =  + dw(ijk, 48,  9)
      JacC(ijk,  5,  9) =  + dw(ijk, 48,  9)
      JacC(ijk,  9,  9) =  - dw(ijk, 48,  9) &
                           - dw(ijk, 49,  9) &
                           - dw(ijk, 50,  9)
      JacC(ijk, 10,  9) = + 0.2000000000000000D+01*dw(ijk, 49,  9) &
                          + 0.2000000000000000D+01*dw(ijk, 50,  9)
      JacC(ijk,  7, 14) =  - dw(ijk, 52, 14) &
                           - dw(ijk, 53, 14)
      JacC(ijk,  8, 14) =  + dw(ijk, 52, 14) &
                           + dw(ijk, 53, 14)
      JacC(ijk, 14, 14) =  - dw(ijk, 52, 14) &
                           - dw(ijk, 53, 14)
      JacC(ijk, 14,  7) =  - dw(ijk, 52,  7) &
                           - dw(ijk, 53,  7) &
                           + dw(ijk, 55,  7) &
                          + 0.3340000000000000D+00*dw(ijk, 81,  7) &
                          + 0.2000000000000000D+01*dw(ijk, 90,  7)
      JacC(ijk,  3, 15) =  - dw(ijk, 54, 15)
      JacC(ijk,  7, 15) =  + dw(ijk, 54, 15) &
                           - dw(ijk, 55, 15)
      JacC(ijk,  7,  3) =  + dw(ijk, 54,  3) &
                           + dw(ijk, 57,  3) &
                          + 0.3500000000000000D+00*dw(ijk, 69,  3) &
                          + 0.5100000000000000D-01*dw(ijk, 72,  3)
      JacC(ijk,  8,  3) =  + dw(ijk, 54,  3) &
                          + 0.1550000000000000D+01*dw(ijk, 69,  3) &
                          + 0.1470000000000000D+00*dw(ijk, 72,  3) &
                          + 0.2500000000000000D+00*dw(ijk, 76,  3)
      JacC(ijk, 14,  3) =  + dw(ijk, 54,  3) &
                          + 0.9500000000000000D+00*dw(ijk, 69,  3) &
                          + 0.1020000000000000D+00*dw(ijk, 72,  3)
      JacC(ijk, 15,  3) =  - dw(ijk, 54,  3) &
                          + 0.4900000000000000D+00*dw(ijk, 69,  3) &
                          + 0.5100000000000000D-01*dw(ijk, 72,  3) &
                          + 0.5000000000000000D+00*dw(ijk, 76,  3)
      JacC(ijk, 15,  7) =  - dw(ijk, 55,  7) &
                          + 0.1560000000000000D+01*dw(ijk, 70,  7) &
                           + dw(ijk, 73,  7) &
                          + 0.6290000000000000D+00*dw(ijk, 77,  7) &
                          + 0.1670000000000000D+00*dw(ijk, 81,  7) &
                           + dw(ijk, 90,  7) &
                           + dw(ijk,101,  7) &
                           + dw(ijk,102,  7)
      JacC(ijk,  5, 15) =  - dw(ijk, 56, 15)
      JacC(ijk, 10, 15) =  + dw(ijk, 56, 15)
      JacC(ijk, 14,  5) =  + dw(ijk, 56,  5) &
                          + 0.6430000000000000D+00*dw(ijk, 83,  5)
      JacC(ijk, 15,  5) =  - dw(ijk, 56,  5) &
                           + dw(ijk, 75,  5) &
                          + 0.2820000000000000D+00*dw(ijk, 83,  5)
      JacC(ijk,  3, 16) =  - dw(ijk, 57, 16)
      JacC(ijk,  7, 16) =  + dw(ijk, 57, 16) &
                           - dw(ijk, 58, 16)
      JacC(ijk, 16,  3) =  - dw(ijk, 57,  3) &
                          + 0.5190000000000000D+00*dw(ijk, 72,  3)
      JacC(ijk, 17, 16) =  + dw(ijk, 57, 16) &
                           + dw(ijk, 58, 16) &
                           + dw(ijk, 59, 16)
      JacC(ijk, 17,  3) =  + dw(ijk, 57,  3) &
                          + 0.2500000000000000D+00*dw(ijk, 76,  3)
      JacC(ijk, 16,  7) =  - dw(ijk, 58,  7) &
                          + 0.1100000000000000D+00*dw(ijk, 65,  7) &
                          + 0.2200000000000000D+00*dw(ijk, 70,  7) &
                           + dw(ijk, 73,  7) &
                          + 0.2730000000000000D+00*dw(ijk, 81,  7) &
                           + dw(ijk,103,  7)
      JacC(ijk, 17,  7) =  + dw(ijk, 58,  7) &
                          + 0.4980000000000000D+00*dw(ijk, 81,  7) &
                           + dw(ijk, 90,  7) &
                           + dw(ijk, 93,  7)
      JacC(ijk,  5, 16) =  - dw(ijk, 59, 16)
      JacC(ijk, 10, 16) =  + dw(ijk, 59, 16)
      JacC(ijk, 16,  5) =  - dw(ijk, 59,  5) &
                           + dw(ijk, 75,  5) &
                          + 0.8000000000000000D+00*dw(ijk, 79,  5) &
                          + 0.3570000000000000D+00*dw(ijk, 83,  5)
      JacC(ijk, 17,  5) =  + dw(ijk, 59,  5) &
                          + 0.7500000000000000D-01*dw(ijk, 83,  5)
      JacC(ijk,  1, 17) =  + dw(ijk, 60, 17) &
                           - dw(ijk, 61, 17)
      JacC(ijk,  2, 17) =  - dw(ijk, 60, 17)
      JacC(ijk,  8, 17) =  + dw(ijk, 60, 17) &
                           - dw(ijk, 63, 17) &
                          + 0.2000000000000000D+01*dw(ijk, 64, 17) &
                          + 0.2000000000000000D+01*dw(ijk, 64, 17)
      JacC(ijk, 15, 17) =  + dw(ijk, 60, 17) &
                          + 0.2000000000000000D+01*dw(ijk, 64, 17) &
                          + 0.2000000000000000D+01*dw(ijk, 64, 17)
      JacC(ijk, 15,  2) =  + dw(ijk, 60,  2)
      JacC(ijk, 17, 17) =  - dw(ijk, 60, 17) &
                           - dw(ijk, 61, 17) &
                           - dw(ijk, 63, 17) &
                          - 0.2000000000000000D+01*dw(ijk, 64, 17) &
                          - 0.2000000000000000D+01*dw(ijk, 64, 17)
      JacC(ijk, 17,  2) =  - dw(ijk, 60,  2)
      JacC(ijk, 18, 17) =  + dw(ijk, 60, 17) &
                          + 0.2000000000000000D+01*dw(ijk, 64, 17) &
                          + 0.2000000000000000D+01*dw(ijk, 64, 17)
      JacC(ijk, 18,  2) =  + dw(ijk, 60,  2) &
                           - dw(ijk, 94,  2)
      JacC(ijk, 17,  1) =  - dw(ijk, 61,  1)
      JacC(ijk, 19, 17) =  + dw(ijk, 61, 17)
      JacC(ijk, 19,  1) =  + dw(ijk, 61,  1)
      JacC(ijk,  1, 19) =  + dw(ijk, 62, 19)
      JacC(ijk, 17, 19) =  + dw(ijk, 62, 19)
      JacC(ijk, 19, 19) =  - dw(ijk, 62, 19)
      JacC(ijk,  4, 17) = + 0.2500000000000000D+00*dw(ijk, 63, 17)
      JacC(ijk, 17,  8) =  - dw(ijk, 63,  8)
      JacC(ijk,  7, 20) =  - dw(ijk, 65, 20)
      JacC(ijk,  8, 20) = + 0.1100000000000000D+00*dw(ijk, 65, 20)
      JacC(ijk, 16, 20) = + 0.1100000000000000D+00*dw(ijk, 65, 20)
      JacC(ijk, 18,  7) = + 0.8700000000000000D+00*dw(ijk, 65,  7) &
                           + dw(ijk, 70,  7) &
                           + dw(ijk, 73,  7) &
                          + 0.9910000000000000D+00*dw(ijk, 77,  7) &
                          + 0.7130000000000000D+00*dw(ijk, 81,  7) &
                          + 0.8000000000000000D-01*dw(ijk, 84,  7) &
                          + 0.6000000000000000D+00*dw(ijk, 87,  7) &
                           + dw(ijk, 90,  7) &
                          + 0.1000000000000000D+00*dw(ijk, 92,  7) &
                           + dw(ijk, 93,  7) &
                           + dw(ijk,101,  7)
      JacC(ijk, 18, 20) = + 0.8700000000000000D+00*dw(ijk, 65, 20)
      JacC(ijk, 20,  7) = - 0.1110000000000000D+01*dw(ijk, 65,  7) &
                           - dw(ijk, 73,  7) &
                          + 0.1565000000000000D+01*dw(ijk, 81,  7) &
                          + 0.1100000000000000D+01*dw(ijk, 92,  7)
      JacC(ijk, 20, 20) = - 0.1110000000000000D+01*dw(ijk, 65, 20)
      JacC(ijk, 21,  7) = + 0.1300000000000000D+00*dw(ijk, 65,  7) &
                          + 0.8799999999999999D-01*dw(ijk, 77,  7)
      JacC(ijk, 21, 20) = + 0.1300000000000000D+00*dw(ijk, 65, 20)
      JacC(ijk, 22,  7) = + 0.7600000000000000D+00*dw(ijk, 65,  7)
      JacC(ijk, 22, 20) = + 0.7600000000000000D+00*dw(ijk, 65, 20)
      JacC(ijk,  8, 22) = + 0.9399999999999999D+00*dw(ijk, 66, 22) &
                           + dw(ijk, 67, 22)
      JacC(ijk, 16, 22) = + 0.1100000000000000D+01*dw(ijk, 66, 22)
      JacC(ijk, 18, 22) = + 0.9600000000000000D+00*dw(ijk, 66, 22)
      JacC(ijk, 20, 22) = - 0.2100000000000000D+01*dw(ijk, 66, 22)
      JacC(ijk, 21, 22) = + 0.4000000000000000D-01*dw(ijk, 66, 22)
      JacC(ijk, 22, 22) = - 0.9800000000000000D+00*dw(ijk, 66, 22) &
                           - dw(ijk, 67, 22) &
                           - dw(ijk, 68, 22)
      JacC(ijk,  1, 22) =  - dw(ijk, 68, 22)
      JacC(ijk, 22,  1) =  - dw(ijk, 68,  1)
      JacC(ijk,  3, 24) =  - dw(ijk, 69, 24)
      JacC(ijk,  7, 24) = + 0.3500000000000000D+00*dw(ijk, 69, 24) &
                           - dw(ijk, 70, 24) &
                          + 0.8000000000000000D-01*dw(ijk, 71, 24)
      JacC(ijk,  8, 24) = + 0.1550000000000000D+01*dw(ijk, 69, 24) &
                           + dw(ijk, 70, 24) &
                          + 0.8000000000000000D-01*dw(ijk, 71, 24)
      JacC(ijk, 14, 24) = + 0.9500000000000000D+00*dw(ijk, 69, 24) &
                          + 0.3250000000000000D+00*dw(ijk, 71, 24)
      JacC(ijk, 15, 24) = + 0.4900000000000000D+00*dw(ijk, 69, 24) &
                          + 0.1560000000000000D+01*dw(ijk, 70, 24) &
                          + 0.1030000000000000D+01*dw(ijk, 71, 24)
      JacC(ijk, 18,  3) = + 0.6000000000000000D+00*dw(ijk, 69,  3) &
                          + 0.9700000000000000D-01*dw(ijk, 72,  3) &
                          + 0.2500000000000000D+00*dw(ijk, 76,  3)
      JacC(ijk, 18, 24) = + 0.6000000000000000D+00*dw(ijk, 69, 24) &
                           + dw(ijk, 70, 24)
      JacC(ijk, 24,  3) =  - dw(ijk, 69,  3)
      JacC(ijk, 24, 24) =  - dw(ijk, 69, 24) &
                           - dw(ijk, 70, 24) &
                           - dw(ijk, 71, 24)
      JacC(ijk, 16, 24) = + 0.2200000000000000D+00*dw(ijk, 70, 24)
      JacC(ijk, 24,  7) =  - dw(ijk, 70,  7)
      JacC(ijk,  4, 24) =  - dw(ijk, 71, 24)
      JacC(ijk, 13,  4) = + 0.2000000000000000D-01*dw(ijk, 71,  4)
      JacC(ijk, 13, 24) = + 0.2000000000000000D-01*dw(ijk, 71, 24)
      JacC(ijk, 14,  4) = + 0.3250000000000000D+00*dw(ijk, 71,  4) &
                          + 0.1300000000000000D+00*dw(ijk, 74,  4) &
                          + 0.6600000000000000D-01*dw(ijk, 78,  4) &
                          + 0.2250000000000000D+00*dw(ijk, 82,  4) &
                          + 0.6899999999999999D+00*dw(ijk, 91,  4)
      JacC(ijk, 15,  4) = + 0.1030000000000000D+01*dw(ijk, 71,  4) &
                          + 0.4850000000000000D+00*dw(ijk, 74,  4) &
                          + 0.6000000000000000D+00*dw(ijk, 78,  4) &
                          + 0.1500000000000000D+00*dw(ijk, 82,  4) &
                          + 0.7000000000000000D+00*dw(ijk, 91,  4)
      JacC(ijk, 24,  4) =  - dw(ijk, 71,  4)
      JacC(ijk,  3, 23) =  - dw(ijk, 72, 23)
      JacC(ijk,  7, 23) = + 0.5100000000000000D-01*dw(ijk, 72, 23) &
                           - dw(ijk, 73, 23) &
                          + 0.8500000000000001D-01*dw(ijk, 74, 23)
      JacC(ijk,  8, 23) = + 0.1470000000000000D+00*dw(ijk, 72, 23) &
                           + dw(ijk, 73, 23) &
                          + 0.1500000000000000D+00*dw(ijk, 74, 23)
      JacC(ijk, 14, 23) = + 0.1020000000000000D+00*dw(ijk, 72, 23) &
                          + 0.1300000000000000D+00*dw(ijk, 74, 23)
      JacC(ijk, 15, 23) = + 0.5100000000000000D-01*dw(ijk, 72, 23) &
                           + dw(ijk, 73, 23) &
                          + 0.4850000000000000D+00*dw(ijk, 74, 23) &
                           + dw(ijk, 75, 23)
      JacC(ijk, 16, 23) = + 0.5190000000000000D+00*dw(ijk, 72, 23) &
                           + dw(ijk, 73, 23) &
                          + 0.2100000000000000D+00*dw(ijk, 74, 23) &
                           + dw(ijk, 75, 23)
      JacC(ijk, 18, 23) = + 0.9700000000000000D-01*dw(ijk, 72, 23) &
                           + dw(ijk, 73, 23) &
                          + 0.4400000000000000D-01*dw(ijk, 74, 23) &
                          + 0.7000000000000000D+00*dw(ijk, 75, 23)
      JacC(ijk, 20,  3) = + 0.8090000000000001D+00*dw(ijk, 72,  3) &
                          + 0.2500000000000000D+00*dw(ijk, 76,  3)
      JacC(ijk, 20, 23) = + 0.8090000000000001D+00*dw(ijk, 72, 23) &
                           - dw(ijk, 73, 23) &
                          + 0.9660000000000000D+00*dw(ijk, 74, 23) &
                           - dw(ijk, 75, 23)
      JacC(ijk, 21,  3) = + 0.5000000000000000D-02*dw(ijk, 72,  3)
      JacC(ijk, 21, 23) = + 0.5000000000000000D-02*dw(ijk, 72, 23) &
                          + 0.1000000000000000D-02*dw(ijk, 74, 23) &
                          + 0.3000000000000000D+00*dw(ijk, 75, 23)
      JacC(ijk, 23,  3) =  - dw(ijk, 72,  3)
      JacC(ijk, 23, 23) =  - dw(ijk, 72, 23) &
                           - dw(ijk, 73, 23) &
                           - dw(ijk, 74, 23) &
                           - dw(ijk, 75, 23)
      JacC(ijk, 23,  7) =  - dw(ijk, 73,  7)
      JacC(ijk,  4, 23) =  - dw(ijk, 74, 23)
      JacC(ijk, 16,  4) = + 0.2100000000000000D+00*dw(ijk, 74,  4) &
                          + 0.1500000000000000D+00*dw(ijk, 78,  4) &
                          + 0.2000000000000000D-01*dw(ijk, 82,  4) &
                          + 0.3000000000000000D-01*dw(ijk, 91,  4)
      JacC(ijk, 18,  4) = + 0.4400000000000000D-01*dw(ijk, 74,  4) &
                          + 0.2000000000000000D+00*dw(ijk, 78,  4) &
                          + 0.6400000000000000D-01*dw(ijk, 82,  4) &
                          + 0.3000000000000000D-01*dw(ijk, 91,  4)
      JacC(ijk, 20,  4) = + 0.9660000000000000D+00*dw(ijk, 74,  4) &
                          + 0.3500000000000000D+00*dw(ijk, 78,  4) &
                          + 0.3600000000000000D+00*dw(ijk, 82,  4)
      JacC(ijk, 21,  4) = + 0.1000000000000000D-02*dw(ijk, 74,  4)
      JacC(ijk, 23,  4) =  - dw(ijk, 74,  4)
      JacC(ijk,  1, 23) =  + dw(ijk, 75, 23)
      JacC(ijk,  5, 23) =  - dw(ijk, 75, 23)
      JacC(ijk, 18,  5) = + 0.7000000000000000D+00*dw(ijk, 75,  5) &
                           + dw(ijk, 79,  5) &
                          + 0.7500000000000000D-01*dw(ijk, 83,  5)
      JacC(ijk, 20,  5) =  - dw(ijk, 75,  5) &
                          + 0.2400000000000000D+01*dw(ijk, 79,  5) &
                          + 0.1282000000000000D+01*dw(ijk, 83,  5)
      JacC(ijk, 21,  5) = + 0.3000000000000000D+00*dw(ijk, 75,  5)
      JacC(ijk, 23,  5) =  - dw(ijk, 75,  5)
      JacC(ijk,  3, 32) =  - dw(ijk, 76, 32)
      JacC(ijk,  8, 32) = + 0.2500000000000000D+00*dw(ijk, 76, 32) &
                          + 0.9120000000000000D+00*dw(ijk, 77, 32) &
                          + 0.6600000000000000D-01*dw(ijk, 78, 32) &
                          + 0.8000000000000000D+00*dw(ijk, 79, 32) &
                          + 0.8000000000000000D+00*dw(ijk, 80, 32)
      JacC(ijk, 15, 32) = + 0.5000000000000000D+00*dw(ijk, 76, 32) &
                          + 0.6290000000000000D+00*dw(ijk, 77, 32) &
                          + 0.6000000000000000D+00*dw(ijk, 78, 32)
      JacC(ijk, 17, 32) = + 0.2500000000000000D+00*dw(ijk, 76, 32) &
                          + 0.2000000000000000D+00*dw(ijk, 78, 32)
      JacC(ijk, 18, 32) = + 0.2500000000000000D+00*dw(ijk, 76, 32) &
                          + 0.9910000000000000D+00*dw(ijk, 77, 32) &
                          + 0.2000000000000000D+00*dw(ijk, 78, 32) &
                           + dw(ijk, 79, 32) &
                           + dw(ijk, 80, 32)
      JacC(ijk, 20, 32) = + 0.2500000000000000D+00*dw(ijk, 76, 32) &
                          + 0.3500000000000000D+00*dw(ijk, 78, 32) &
                          + 0.2400000000000000D+01*dw(ijk, 79, 32) &
                          + 0.2400000000000000D+01*dw(ijk, 80, 32)
      JacC(ijk, 32,  3) =  - dw(ijk, 76,  3)
      JacC(ijk, 32, 32) =  - dw(ijk, 76, 32) &
                           - dw(ijk, 77, 32) &
                           - dw(ijk, 78, 32) &
                           - dw(ijk, 79, 32) &
                           - dw(ijk, 80, 32)
      JacC(ijk, 33,  3) = + 0.7500000000000000D+00*dw(ijk, 76,  3)
      JacC(ijk, 33, 32) = + 0.7500000000000000D+00*dw(ijk, 76, 32) &
                          + 0.9120000000000000D+00*dw(ijk, 77, 32) &
                          + 0.6500000000000000D+00*dw(ijk, 78, 32) &
                          + 0.6500000000000000D+00*dw(ijk, 79, 32) &
                          + 0.2000000000000000D+00*dw(ijk, 80, 32)
      JacC(ijk,  7, 32) =  - dw(ijk, 77, 32) &
                          + 0.2660000000000000D+00*dw(ijk, 78, 32)
      JacC(ijk, 21, 32) = + 0.8799999999999999D-01*dw(ijk, 77, 32)
      JacC(ijk, 32,  7) =  - dw(ijk, 77,  7)
      JacC(ijk, 33,  7) = + 0.9120000000000000D+00*dw(ijk, 77,  7) &
                           - dw(ijk, 81,  7)
      JacC(ijk,  4, 32) =  - dw(ijk, 78, 32)
      JacC(ijk, 14, 32) = + 0.6600000000000000D-01*dw(ijk, 78, 32)
      JacC(ijk, 16, 32) = + 0.1500000000000000D+00*dw(ijk, 78, 32) &
                          + 0.8000000000000000D+00*dw(ijk, 79, 32) &
                          + 0.8000000000000000D+00*dw(ijk, 80, 32)
      JacC(ijk, 17,  4) = + 0.2000000000000000D+00*dw(ijk, 78,  4) &
                          + 0.1140000000000000D+00*dw(ijk, 82,  4) &
                          + 0.6200000000000000D+00*dw(ijk, 91,  4)
      JacC(ijk, 32,  4) =  - dw(ijk, 78,  4)
      JacC(ijk, 33,  4) = + 0.6500000000000000D+00*dw(ijk, 78,  4) &
                           - dw(ijk, 82,  4)
      JacC(ijk,  1, 32) = + 0.2000000000000000D+00*dw(ijk, 79, 32) &
                           - dw(ijk, 80, 32)
      JacC(ijk,  5, 32) =  - dw(ijk, 79, 32)
      JacC(ijk, 32,  5) =  - dw(ijk, 79,  5)
      JacC(ijk, 33,  5) = + 0.6500000000000000D+00*dw(ijk, 79,  5) &
                           - dw(ijk, 83,  5)
      JacC(ijk,  2, 32) = + 0.2000000000000000D+00*dw(ijk, 80, 32)
      JacC(ijk, 16,  1) = + 0.8000000000000000D+00*dw(ijk, 80,  1)
      JacC(ijk, 18,  1) =  + dw(ijk, 80,  1)
      JacC(ijk, 20,  1) = + 0.2400000000000000D+01*dw(ijk, 80,  1)
      JacC(ijk, 32,  1) =  - dw(ijk, 80,  1)
      JacC(ijk, 33,  1) = + 0.2000000000000000D+00*dw(ijk, 80,  1)
      JacC(ijk,  7, 33) =  - dw(ijk, 81, 33) &
                          + 0.2680000000000000D+00*dw(ijk, 82, 33)
      JacC(ijk, 30, 33) = + 0.1680000000000000D+00*dw(ijk, 81, 33) &
                          + 0.8500000000000000D+00*dw(ijk, 82, 33)
      JacC(ijk, 30,  7) = + 0.1680000000000000D+00*dw(ijk, 81,  7) &
                          + 0.8000000000000000D+00*dw(ijk, 92,  7) &
                           - dw(ijk, 93,  7)
      JacC(ijk,  4, 33) =  - dw(ijk, 82, 33)
      JacC(ijk, 30,  4) = + 0.8500000000000000D+00*dw(ijk, 82,  4) &
                          + 0.2000000000000000D+00*dw(ijk, 91,  4)
      JacC(ijk,  5, 33) =  - dw(ijk, 83, 33)
      JacC(ijk, 10, 33) = + 0.7500000000000000D-01*dw(ijk, 83, 33)
      JacC(ijk,  7, 25) =  - dw(ijk, 84, 25)
      JacC(ijk,  8, 25) = + 0.4400000000000000D+00*dw(ijk, 84, 25)
      JacC(ijk, 18, 25) = + 0.8000000000000000D-01*dw(ijk, 84, 25)
      JacC(ijk, 25,  7) =  - dw(ijk, 84,  7)
      JacC(ijk, 25, 25) =  - dw(ijk, 84, 25)
      JacC(ijk, 26,  7) = + 0.3600000000000000D+00*dw(ijk, 84,  7) &
                           - dw(ijk, 87,  7) &
                          + 0.2000000000000000D+00*dw(ijk, 92,  7)
      JacC(ijk, 26, 25) = + 0.3600000000000000D+00*dw(ijk, 84, 25)
      JacC(ijk, 27,  7) = + 0.5600000000000001D+00*dw(ijk, 84,  7) &
                          + 0.3000000000000000D+00*dw(ijk, 92,  7)
      JacC(ijk, 27, 25) = + 0.5600000000000001D+00*dw(ijk, 84, 25)
      JacC(ijk,  1, 27) = + 0.9000000000000000D+00*dw(ijk, 85, 27)
      JacC(ijk,  2, 27) =  - dw(ijk, 85, 27)
      JacC(ijk,  8, 27) = + 0.9000000000000000D+00*dw(ijk, 85, 27) &
                           + dw(ijk, 86, 27)
      JacC(ijk, 27, 27) =  - dw(ijk, 85, 27) &
                           - dw(ijk, 86, 27)
      JacC(ijk, 27,  2) =  - dw(ijk, 85,  2)
      JacC(ijk, 28, 27) = + 0.9000000000000000D+00*dw(ijk, 85, 27)
      JacC(ijk, 28,  2) = + 0.9000000000000000D+00*dw(ijk, 85,  2)
      JacC(ijk, 26, 27) =  + dw(ijk, 86, 27)
      JacC(ijk,  7, 26) =  - dw(ijk, 87, 26)
      JacC(ijk,  8, 26) = + 0.6000000000000000D+00*dw(ijk, 87, 26)
      JacC(ijk, 18, 26) = + 0.6000000000000000D+00*dw(ijk, 87, 26)
      JacC(ijk, 26, 26) =  - dw(ijk, 87, 26) &
                           - dw(ijk, 88, 26)
      JacC(ijk, 28,  7) = + 0.3000000000000000D+00*dw(ijk, 87,  7) &
                           - dw(ijk, 90,  7)
      JacC(ijk, 28, 26) = + 0.3000000000000000D+00*dw(ijk, 87, 26)
      JacC(ijk, 29,  7) = + 0.4000000000000000D+00*dw(ijk, 87,  7)
      JacC(ijk, 29, 26) = + 0.4000000000000000D+00*dw(ijk, 87, 26) &
                           + dw(ijk, 88, 26)
      JacC(ijk,  5, 26) =  - dw(ijk, 88, 26)
      JacC(ijk, 10, 26) =  + dw(ijk, 88, 26)
      JacC(ijk, 26,  5) =  - dw(ijk, 88,  5)
      JacC(ijk, 29,  5) =  + dw(ijk, 88,  5)
      JacC(ijk,  1, 29) =  - dw(ijk, 89, 29)
      JacC(ijk, 29, 29) =  - dw(ijk, 89, 29)
      JacC(ijk, 29,  1) =  - dw(ijk, 89,  1)
      JacC(ijk,  7, 28) =  - dw(ijk, 90, 28) &
                          + 0.8000000000000000D-01*dw(ijk, 91, 28)
      JacC(ijk, 15, 28) =  + dw(ijk, 90, 28) &
                          + 0.7000000000000000D+00*dw(ijk, 91, 28)
      JacC(ijk, 18, 28) =  + dw(ijk, 90, 28) &
                          + 0.3000000000000000D-01*dw(ijk, 91, 28)
      JacC(ijk,  4, 28) =  - dw(ijk, 91, 28)
      JacC(ijk, 16, 28) = + 0.3000000000000000D-01*dw(ijk, 91, 28)
      JacC(ijk, 28,  4) =  - dw(ijk, 91,  4)
      JacC(ijk, 30, 28) = + 0.2000000000000000D+00*dw(ijk, 91, 28)
      JacC(ijk,  7, 31) =  - dw(ijk, 92, 31)
      JacC(ijk,  8, 31) = + 0.7000000000000000D+00*dw(ijk, 92, 31)
      JacC(ijk, 18, 31) = + 0.1000000000000000D+00*dw(ijk, 92, 31)
      JacC(ijk, 20, 31) = + 0.1100000000000000D+01*dw(ijk, 92, 31)
      JacC(ijk, 26, 31) = + 0.2000000000000000D+00*dw(ijk, 92, 31)
      JacC(ijk, 27, 31) = + 0.3000000000000000D+00*dw(ijk, 92, 31)
      JacC(ijk, 30, 31) = + 0.8000000000000000D+00*dw(ijk, 92, 31)
      JacC(ijk, 31,  7) =  - dw(ijk, 92,  7)
      JacC(ijk, 31, 31) =  - dw(ijk, 92, 31)
      JacC(ijk,  7, 30) =  - dw(ijk, 93, 30)
      JacC(ijk, 18, 30) =  + dw(ijk, 93, 30)
      JacC(ijk,  1, 18) =  + dw(ijk, 94, 18)
      JacC(ijk,  2, 18) =  - dw(ijk, 94, 18)
      JacC(ijk, 18, 18) =  - dw(ijk, 94, 18) &
                          - 0.2000000000000000D+01*dw(ijk, 96, 18) &
                          - 0.2000000000000000D+01*dw(ijk, 96, 18) &
                           - dw(ijk, 97, 18) &
                           - dw(ijk,100, 18)
      JacC(ijk,  2, 21) =  - dw(ijk, 95, 21)
      JacC(ijk, 21, 21) =  - dw(ijk, 95, 21) &
                           - dw(ijk, 98, 21) &
                          - 0.2000000000000000D+01*dw(ijk, 99, 21) &
                          - 0.2000000000000000D+01*dw(ijk, 99, 21) &
                           - dw(ijk,100, 21)
      JacC(ijk, 21,  2) =  - dw(ijk, 95,  2)
      JacC(ijk,  8, 18) =  - dw(ijk, 97, 18)
      JacC(ijk, 18,  8) =  - dw(ijk, 97,  8)
      JacC(ijk,  8, 21) =  - dw(ijk, 98, 21)
      JacC(ijk, 21,  8) =  - dw(ijk, 98,  8)
      JacC(ijk, 18, 21) =  - dw(ijk,100, 21)
      JacC(ijk, 21, 18) =  - dw(ijk,100, 18)
      JacC(ijk,  7, 34) =  - dw(ijk,101, 34)
      JacC(ijk,  8, 34) =  + dw(ijk,101, 34)
      JacC(ijk, 15, 34) =  + dw(ijk,101, 34)
      JacC(ijk, 18, 34) =  + dw(ijk,101, 34)
      JacC(ijk, 34, 34) =  - dw(ijk,101, 34)
      JacC(ijk, 34,  7) =  - dw(ijk,101,  7)
      JacC(ijk,  7, 35) =  - dw(ijk,102, 35)
      JacC(ijk,  8, 35) =  + dw(ijk,102, 35)
      JacC(ijk, 15, 35) =  + dw(ijk,102, 35)
      JacC(ijk, 35, 35) =  - dw(ijk,102, 35)
      JacC(ijk, 35,  7) =  - dw(ijk,102,  7)
      JacC(ijk,  7, 36) =  - dw(ijk,103, 36)
      JacC(ijk,  8, 36) =  + dw(ijk,103, 36)
      JacC(ijk, 16, 36) =  + dw(ijk,103, 36)
      JacC(ijk, 36, 36) =  - dw(ijk,103, 36)
      JacC(ijk, 36,  7) =  - dw(ijk,103,  7)
       END DO                                                                                                                                         
                                                                                                                                                      
   END SUBROUTINE jacdchemdc                                                                                                                          
                                                                                                                                                      
  END MODULE mod_chem_spack_jacdchemdc                                                                                                                
                                                                                                                                                      
